package com.oracle.jpa.bugtest;

import jakarta.persistence.Embeddable;

import java.io.Serializable;
import java.util.Objects;

@Embeddable
public class EmbeddedPK implements Serializable {

    private int id_int;
    private String id_string;

    public EmbeddedPK() {
        this(0, null);
    }

    public EmbeddedPK(int id_int, String id_string) {
        this.id_int = id_int;
        this.id_string = id_string;
    }

    public int getId_int() {
        return id_int;
    }

    public void setId_int(int id_int) {
        this.id_int = id_int;
    }

    public String getId_string() {
        return id_string;
    }

    public void setId_string(String id_string) {
        this.id_string = id_string;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        EmbeddedPK that = (EmbeddedPK) o;
        return id_int == that.id_int && Objects.equals(id_string, that.id_string);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id_int, id_string);
    }
}
