package com.oracle.jpa.bugtest;

import java.time.Instant;
import java.util.Objects;

public record NestedDetailRecord(float floatAttribute, Instant instantAttribute) {

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        NestedDetailRecord that = (NestedDetailRecord) o;
        return Float.compare(floatAttribute, that.floatAttribute) == 0 && Objects.equals(instantAttribute, that.instantAttribute);
    }

    @Override
    public int hashCode() {
        return Objects.hash(floatAttribute, instantAttribute);
    }
}
