package com.oracle.jpa.bugtest;

import java.util.Objects;

public record NestedMasterRecord(int intAttribute, String stringAttribute, NestedDetailRecord nestedDetailRecord) {

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        NestedMasterRecord that = (NestedMasterRecord) o;
        return intAttribute == that.intAttribute && Objects.equals(stringAttribute, that.stringAttribute) && Objects.equals(nestedDetailRecord, that.nestedDetailRecord);
    }

    @Override
    public int hashCode() {
        return Objects.hash(intAttribute, stringAttribute, nestedDetailRecord);
    }
}
