package com.oracle.jpa.bugtest;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import jakarta.persistence.Version;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;

@Entity
@Table(name = "TEST_TAB_REBATE")
public class Rebate {

    public Rebate(Integer id, double amount, String customerId, LocalTime purchaseMadeAt, LocalDate purchaseMadeOn, Status status, LocalDateTime updatedAt, Integer version) {
        this.id = id;
        this.amount = amount;
        this.customerId = customerId;
        this.purchaseMadeAt = purchaseMadeAt;
        this.purchaseMadeOn = purchaseMadeOn;
        this.status = status;
        this.updatedAt = updatedAt;
        this.version = version;
    }

    @Id
    @GeneratedValue
    public Integer id;

    public double amount;

    @Column(name = "CUSTOMER_ID")
    public String customerId;

    @Column(name = "PURCHASE_MADE_AT")
    public LocalTime purchaseMadeAt;

    @Column(name = "PURCHASE_MADE_ON")
    public LocalDate purchaseMadeOn;

    public Rebate.Status status;

    @Column(name = "UPDATED_AT")
    public LocalDateTime updatedAt;

    @Version
    Integer version;

    public Rebate() {
    }

    public static Rebate of(double amount, String customerId, LocalTime purchaseMadeAt, LocalDate purchaseMadeOn, Status status, LocalDateTime updatedAt, int version) {
        Rebate inst = new Rebate();
        inst.amount = amount;
        inst.customerId = customerId;
        inst.purchaseMadeAt = purchaseMadeAt;
        inst.purchaseMadeOn = purchaseMadeOn;
        inst.status = status;
        inst.updatedAt = updatedAt;
        inst.version = version;

        return inst;
    }

    public static enum Status {
        DENIED, SUBMITTED, VERIFIED, PAID
    }
}
