package com.oracle.jpa.bugtest;

import jakarta.persistence.Embeddable;
import jakarta.persistence.Embedded;

import java.util.Objects;

@Embeddable
public record RecordAttribute(@Embedded RecordNestedAttribute nestedAttribute, String name3) {

    public RecordAttribute() {
        this(null, null);
    }

    public RecordAttribute(RecordNestedAttribute nestedAttribute, String name3) {
        this.nestedAttribute = nestedAttribute;
        this.name3 = name3;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        RecordAttribute that = (RecordAttribute) o;
        return Objects.equals(nestedAttribute, that.nestedAttribute) && Objects.equals(name3, that.name3);
    }

    @Override
    public int hashCode() {
        return Objects.hash(nestedAttribute, name3);
    }
}
