package com.oracle.jpa.bugtest;

import jakarta.persistence.Embeddable;
import jakarta.persistence.Embedded;

import java.util.Objects;

@Embeddable
public record RecordNestedAttribute(String name1, String name2) {

    public RecordNestedAttribute() {
        this(null, null);
    }

    public RecordNestedAttribute(String name1, String name2) {
        this.name1 = name1;
        this.name2 = name2;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        RecordNestedAttribute that = (RecordNestedAttribute) o;
        return Objects.equals(name1, that.name1) && Objects.equals(name2, that.name2);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name1, name2);
    }
}
