package com.oracle.jpa.bugtest;

import jakarta.persistence.Embeddable;

import java.io.Serializable;
import java.util.Objects;

@Embeddable
public record RecordPK (int id_int, String id_string) implements Serializable {

    public RecordPK() {
        this(0,null);
    }

    public RecordPK(int id_int, String id_string) {
        this.id_int = id_int;
        this.id_string = id_string;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        RecordPK recordPK = (RecordPK) o;
        return id_int == recordPK.id_int && Objects.equals(id_string, recordPK.id_string);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id_int, id_string);
    }
}
