package com.oracle.jpa.bugtest;

import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "TEST_TAB_DETAIL")
public class TestEntityDetail {

    static final long serialVersionUID = 1L;

    @Id
    private long id;

    private String name;

    @ManyToOne()
    @JoinColumn(name = "MASTER_ID_FK")
    private TestEntityMaster master;

    public TestEntityDetail() {
    }

    public TestEntityDetail(long id) {
        this.id = id;
    }

    public TestEntityDetail(long id, String name) {
        this.id = id;
        this.name = name;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public TestEntityMaster getMaster() {
        return master;
    }

    public void setMaster(TestEntityMaster master) {
        this.master = master;
    }
}
