package com.oracle.jpa.bugtest;

import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;

import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "TEST_TAB_MASTER")
public class TestEntityMaster {

    static final long serialVersionUID = 1L;

    @Id
    private long id;

    private String name;

    @OneToMany(mappedBy = "master")
    private List<TestEntityDetail> details = new ArrayList<>();

    public TestEntityMaster() {
    }

    public TestEntityMaster(long id) {
        this.id = id;
    }
    
    public TestEntityMaster(long id, String name) {
        this.id = id;
        this.name = name;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<TestEntityDetail> getDetails() {
        return details;
    }

    public void setDetails(List<TestEntityDetail> details) {
        this.details = details;
    }
}
