package com.oracle.jpa.bugtest;

import jakarta.persistence.Basic;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import jakarta.persistence.Temporal;
import jakarta.persistence.TemporalType;

import java.sql.Timestamp;
import java.time.Instant;
import java.time.Year;
import java.util.Date;

@Entity
@Table(name = "TEST_TAB_TIMESTAMP")
public class TimestampEntity {

    private long id;
    private Instant instantData;
    private Year yearData;
    private Date dateData;
    private Timestamp tsData;

    protected TimestampEntity() {
    }

    @Id
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @Column(name = "INSTANTSDATA")
    @Basic
    public Instant getInstantData() {
        return instantData;
    }

    public void setInstantData(Instant instantData) {
        this.instantData = instantData;
    }

    @Column(name = "YEARDATA")
    @Basic
    public Year getYearData() {
        return yearData;
    }

    public void setYearData(Year yearData) {
        this.yearData = yearData;
    }

    @Column(name = "DATEDATA")
    @Temporal(TemporalType.DATE)
    @Basic
    public Date getDateData() {
        return dateData;
    }

    public void setDateData(Date dateData) {
        this.dateData = dateData;
    }

    @Column(name = "TSDATA")
    public Timestamp getTsData() {
        return tsData;
    }

    public void setTsData(Timestamp tsData) {
        this.tsData = tsData;
    }
}
