DROP TABLE SEQUENCE;
DROP TABLE TEST_TAB_TIMESTAMP;
DROP TABLE TEST_TAB_RECORD;
DROP TABLE TEST_TAB_EMBEDDED;
DROP TABLE TEST_TAB_NOALIAS;
DROP TABLE TEST_TAB_DEMOGRAPHIC_INFO;
DROP TABLE TEST_TAB_IDVERSION;
DROP TABLE TEST_TAB_COMP_IDVERSION;
DROP TABLE TEST_TAB_DETAIL;
DROP TABLE TEST_TAB_MASTER;
DROP TABLE TEST_TAB_IDCLASS;
ALTER TABLE Rating_COMMENTS DROP CONSTRAINT RtngCOMMENTSRtngID;
DROP TABLE RATING;
DROP TABLE Rating_COMMENTS;
DROP TABLE HOUSE;


CREATE TABLE SEQUENCE  (SEQ_NAME VARCHAR(25) PRIMARY KEY, SEQ_COUNT INTEGER);
CREATE TABLE TEST_TAB_TIMESTAMP (ID INTEGER PRIMARY KEY, INSTANTSDATA TIMESTAMP, YEARDATA INT, DATEDATA DATE, TSDATA TIMESTAMP);
CREATE TABLE TEST_TAB_RECORD (ID_INT INTEGER, ID_STRING  VARCHAR(25), NAME1  VARCHAR(25), NAME2  VARCHAR(25), NAME3  VARCHAR(25), PRIMARY KEY (ID_INT, ID_STRING));
CREATE TABLE ROMAN_NUMERAL (NAME VARCHAR(100),ROMAN_NUMERAL VARCHAR(50),ROMAN_NUMERAL_SYMBOLS TEXT,PRIMARY KEY (NAME,ROMAN_NUMERAL));
CREATE TABLE TEST_TAB_EMBEDDED (ID_INT INTEGER, ID_STRING  VARCHAR(25), NAME1  VARCHAR(25), NAME2  VARCHAR(25), PRIMARY KEY (ID_INT, ID_STRING));
CREATE TABLE TEST_TAB_NOALIAS (ID INTEGER PRIMARY KEY, NAME  VARCHAR(25), collectedOn TIMESTAMP);
CREATE TABLE TEST_TAB_DEMOGRAPHIC_INFO (ID INTEGER PRIMARY KEY, PUBLICDEBT DOUBLE, INTRAGOVERNMENTALDEBT DOUBLE, NUMFULLTIMEWORKERS INTEGER, COLLECTEDON TIMESTAMP);
CREATE TABLE TEST_TAB_IDVERSION (ID INTEGER PRIMARY KEY, NAME  VARCHAR(25), VERSION INTEGER);
CREATE TABLE TEST_TAB_COMP_IDVERSION (ID1 INTEGER, ID2 INTEGER, NAME  VARCHAR(25), VERSION INTEGER, PRIMARY KEY (ID1, ID2));
CREATE TABLE TEST_TAB_IDCLASS (NAME  VARCHAR(25), STATE_NAME  VARCHAR(100), POPULATION  INTEGER, PRIMARY KEY (NAME, STATE_NAME));
CREATE TABLE TEST_TAB_REBATE (ID INTEGER PRIMARY KEY, AMOUNT FLOAT, CUSTOMER_ID VARCHAR(50), PURCHASE_MADE_AT TIME, PURCHASE_MADE_ON DATE, STATUS VARCHAR(10), UPDATED_AT TIMESTAMP, VERSION INTEGER);
CREATE TABLE TEST_TAB_MASTER (ID INTEGER PRIMARY KEY, NAME VARCHAR(200));
CREATE TABLE TEST_TAB_DETAIL (ID INTEGER PRIMARY KEY, MASTER_ID_FK INTEGER, NAME VARCHAR(200));
ALTER TABLE TEST_TAB_DETAIL ADD CONSTRAINT TEST_TAB_FK_DETAIL FOREIGN KEY ( MASTER_ID_FK ) REFERENCES TEST_TAB_MASTER (ID);
CREATE TABLE RATING (ID INTEGER NOT NULL, NUMSTARS INTEGER, NAME VARCHAR(255), PRICE FLOAT, EMAIL VARCHAR(255), FIRSTNAME VARCHAR(255), LASTNAME VARCHAR(255), PRIMARY KEY (ID));
CREATE TABLE Rating_COMMENTS (Rating_ID INTEGER  /*  */ , COMMENTS VARCHAR(255));
ALTER TABLE Rating_COMMENTS ADD CONSTRAINT RtngCOMMENTSRtngID FOREIGN KEY (Rating_ID) REFERENCES RATING (ID);
CREATE TABLE HOUSE (PARCELID VARCHAR(255) NOT NULL, AREA INTEGER, TYPE VARCHAR(255), PRIMARY KEY (PARCELID));


INSERT INTO SEQUENCE (SEQ_NAME, SEQ_COUNT) VALUES ('SEQ_GEN', 0);
INSERT INTO TEST_TAB_RECORD (ID_INT, ID_STRING, NAME1, NAME2, NAME3) VALUES (1, 'a', 'abcde', 'ijkl', 'xyz');
INSERT INTO TEST_TAB_EMBEDDED (ID_INT, ID_STRING, NAME1, NAME2) VALUES (1, 'a', 'abcde', 'xyz');
INSERT INTO TEST_TAB_IDVERSION (ID, NAME, VERSION) VALUES (1, 'abcde', 11);
INSERT INTO TEST_TAB_COMP_IDVERSION (ID1, ID2, NAME, VERSION) VALUES (1, 11, 'xyz', 111);
INSERT INTO TEST_TAB_IDCLASS (NAME, STATE_NAME, POPULATION) VALUES ('cz', 'Czech Republic', 10000000);
INSERT INTO TEST_TAB_IDCLASS (NAME, STATE_NAME, POPULATION) VALUES ('at', 'Austria', 12000000);
INSERT INTO TEST_TAB_IDCLASS (NAME, STATE_NAME, POPULATION) VALUES ('de', 'Germany', 80000000);
INSERT INTO TEST_TAB_MASTER (ID, NAME) VALUES (1, 'Master 1');
INSERT INTO TEST_TAB_MASTER (ID, NAME) VALUES (2, 'Master 2');
INSERT INTO TEST_TAB_DETAIL (ID, MASTER_ID_FK, NAME) VALUES (101, 1, 'Detail 101');
INSERT INTO TEST_TAB_DETAIL (ID, MASTER_ID_FK, NAME) VALUES (102, 1, 'Detail 102');
INSERT INTO TEST_TAB_DETAIL (ID, MASTER_ID_FK, NAME) VALUES (201, 2, 'Detail 201');
INSERT INTO TEST_TAB_DETAIL (ID, MASTER_ID_FK, NAME) VALUES (202, 2, 'Detail 202');
INSERT INTO HOUSE (PARCELID, AREA, TYPE) VALUES ('TestEmbeddable-304-3655-30', NULL, NULL);
INSERT INTO HOUSE (PARCELID, AREA, TYPE) VALUES ('TestEmbeddable-304-3655-31', 200, 'Attached');


SELECT * FROM TEST_TAB_TIMESTAMP;
SELECT * FROM TEST_TAB_RECORD;
SELECT * FROM TEST_TAB_EMBEDDED;
SELECT * FROM TEST_TAB_NOALIAS;
SELECT * FROM TEST_TAB_IDVERSION;
SELECT * FROM TEST_TAB_COMP_IDVERSION;
SELECT * FROM TEST_TAB_IDCLASS;
SELECT * FROM TEST_TAB_REBATE;
SELECT * FROM RATING;
SELECT * FROM Rating_COMMENTS;
SELECT * FROM HOUSE;

DELETE FROM TEST_TAB_RECORD;

COMMIT;