package com.oracle.jpa.bugtest;

import jakarta.persistence.EntityManager;
import jakarta.persistence.EntityManagerFactory;
import jakarta.persistence.Persistence;
import jakarta.persistence.Query;
import org.junit.jupiter.api.Test;

import java.util.List;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNotNull;
import static org.junit.jupiter.api.Assertions.assertNull;

public class TestRecordIdClass {

    private static final String PU_NAME = "test-jpa-record-pu-derby";


    private final String NAME = "cz";


    @Test
    public void queryIDFunctionTest() {
        EntityManagerFactory entityManagerFactory = Persistence.createEntityManagerFactory(PU_NAME);
        assertNotNull(entityManagerFactory);

        EntityManager em = entityManagerFactory.createEntityManager();

        try {
            Query query = em.createQuery("SELECT ID(THIS) FROM IdClassEntity WHERE (name = :nameParam) ORDER BY population DESC");
            query.setParameter("nameParam", NAME);
            Object result = query.getSingleResult();
            System.out.println(result);
/*
            for (RecordEntity entity: result) {
                assertNotNull(entity);

                assertEquals(ID_INT, entity.getId().id_int());
                assertEquals(NAME1, entity.getRecordAttribute().nestedAttribute().name1());
                assertEquals(NAME2, entity.getRecordAttribute().nestedAttribute().name2());
                assertEquals(NAME3, entity.getRecordAttribute().name3());
            }
*/
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
        finally {
            if (em.getTransaction().isActive()) {
                em.getTransaction().rollback();
            }
            em.close();
        }
    }

    @Test
    public void queryTest() {
        EntityManagerFactory entityManagerFactory = Persistence.createEntityManagerFactory(PU_NAME);
        assertNotNull(entityManagerFactory);

        EntityManager em = entityManagerFactory.createEntityManager();

        try {
            Query query = em.createQuery("SELECT this FROM IdClassEntity WHERE (name = :nameParam) ORDER BY population DESC", IdClassEntity.class);
            query.setParameter("nameParam", NAME);
            IdClassEntity result = (IdClassEntity) query.getSingleResult();
            System.out.println(result);
/*
            for (RecordEntity entity: result) {
                assertNotNull(entity);

                assertEquals(ID_INT, entity.getId().id_int());
                assertEquals(NAME1, entity.getRecordAttribute().nestedAttribute().name1());
                assertEquals(NAME2, entity.getRecordAttribute().nestedAttribute().name2());
                assertEquals(NAME3, entity.getRecordAttribute().name3());
            }
*/
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException();
        }
        finally {
            if (em.getTransaction().isActive()) {
                em.getTransaction().rollback();
            }
            em.close();
        }
    }
}
